zoukankan      html  css  js  c++  java
  • hdu 1087 Super Jumping! Jumping! Jumping!

    Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



    The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
    Your task is to output the maximum value according to the given chessmen list.
     

    Input

    Input contains multiple test cases. Each test case is described in a line as follow:
    N value_1 value_2 …value_N 
    It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
    A test case starting with 0 terminates the input and this test case is not to be processed.
     

    Output

    For each case, print the maximum according to rules, and one line one case.
     

    Sample Input

    3 1 3 2
    4 1 2 3 4
    4 3 3 2 1
    0

    Sample Output

    4
    10
    3

    对于dp初始化不能简单地直接赋值为0,因为数组的值可能是负数!!!

    #include <iostream>
    #include <cstring>
    using namespace std;
    const int Max=1000+10;
    int a[Max];
    long long dp[Max];
    int main()
    {
        int n;
        while(cin>>n,n!=0)
        {
            for(int i=1;i<=n;i++) cin>>a[i];
            long long top=a[1];
            for(int i=1;i<=n;i++) dp[i]=a[i];     //while ai may lower than 0,you must init dp array like this
            for(int i=2;i<=n;i++)
            {
                for(int j=1;j<i;j++)
                {
                    if(a[j]<a[i])
                    {
                        if(dp[j]+a[i]>dp[i])
                        {
                            dp[i]=dp[j]+a[i];
                        }
                    }
                }
                top=max(top,dp[i]);
            }
            for(int i=1;i<=n;i++)
            {
                if(top<a[i]) top=a[i];
            }
            cout<<top<<endl;
        }
        return 0;
    }
    View Code
  • 相关阅读:
    Python性能提升小技巧
    算法-第四版-练习1.3.32解答
    算法-第四版-练习1.3.30解答
    算法-第四版-练习1.3.31解答
    算法-第四版-练习1.3.29解答
    PAT (Basic Level) Practise:1030. 完美数列
    PAT (Basic Level) Practise:1010. 一元多项式求导
    PAT (Basic Level) Practise:1012. 数字分类
    PAT (Basic Level) Practise:1038. 统计同成绩学生
    PAT (Basic Level) Practise:1018. 锤子剪刀布
  • 原文地址:https://www.cnblogs.com/zsyacm666666/p/5259986.html
Copyright © 2011-2022 走看看